# include <stdio.h>
# include <stdlib.h>
# include <string.h>
# include "mplib.h"
# include "mplibps.h"
# define EXECUTE mp_execute ( mp, command, strlen ( command ) )

void print_ptr_list ( mp_knot * curnode ) ;

int main ( int argc, char * argv [] ) 
{
	MP mp ;
	MP_options * opt = mp_options () ;
	opt -> command_line = argv [ 1 ] ;
	opt -> noninteractive = 1 ;
	mp = mp_initialize ( opt ) ;
	if ( ! mp ) exit ( EXIT_FAILURE ) ;

	char * command ;
	mp_run_data * results ;
	mp_edge_object * curfig ;
	mp_graphic_object * curobj ;
	mp_stroked_object * strobj ;
	int fignum, objnum ;
	
	command = "input plain ;" ; EXECUTE ;
	command = "beginfig ( 10 ) ; draw ( 0, 0 ) .. ( 2, 20 ) -- ( 10, 5 ) .. ( 3, 10 ) .. cycle ; endfig ; end ;" ; EXECUTE ;
	
	results = mp_rundata ( mp ) ;
	curfig = results -> edges ;
	curobj = curfig -> body ;
	strobj = ( mp_stroked_object * ) curobj ;
	printf ( "Pen  :\n" ) ;
	print_ptr_list ( strobj -> pen_p ) ;
	printf ( "Path :\n" ) ;
	print_ptr_list ( strobj -> path_p ) ;
	
	mp_finish ( mp ) ;
}

void print_ptr_list ( mp_knot * curnode )
{
	int nodenum ;
	for ( nodenum = 1 ; nodenum <= 10 ; ++ nodenum )
	{
		printf ( "Node #%d Ptr %x\n", nodenum, ( unsigned int ) curnode ) ;
		curnode = curnode -> next ;
	}
}
